Attribute VB_Name = "CommonDialogOcx"
'********************************************************************
'**********         Modulo per l'utilizzo del Common Dialog 6 *******
'********************************************************************
'Dichiarazione Costanti dei Flags

'Show Color
'Private Const cdlCCFullOpen = &H2        'Apertura Totale
'Private Const cdlCCHelpButton = &H8      'Visualizza Help Button
'Private Const cdlCCPreventFullOpen = &H4 'Non permette Definizione di nuovi colori e apertura totale
'Private Const cdlCCRGBInit = &H1         'Setta il colore inizile

'Show Fonts
'Private Const cdlCFANSIOnly = &H400     'Solo Fonts con Windows Chars
'Private Const cdlCFApply = &H200        'Autorizza Apply Button
'Private Const cdlCFBoth = &H3           'Visualizza i Fonts dello Screen e della stampante hDC
'Private Const cdlCFEffects = &H100      'Autorizza strikethrough, underline, e effetti Colore
'Private Const cdlCFFixedPitchOnly = &H4000 'Solo fixed-pitch fonts.
Private Const cdlCFForceFontExist = &H10000 'Messaggio se Utente sceglie Font inesistente
'Private Const cdlCFHelpButton = &H4         'Help Button
'Private Const cdlCFLimitSize = &H2000       'Solo FontSize fra Min e Max
'Private Const cdlCFNoFaceSel = &H80000      'Nessun font Name Scelto
'Private Const cdlCFNoSimulations = &H1000   'Non autorizza graphic device interface (GDI) font simulations.
'Private Const cdlCFNoSizeSel = &H200000     'Nessun font size Scelto
'Private Const cdlCFNoStyleSel = &H100000    'NON SPECIFICATO DALL'HELP!!!!
'Private Const cdlCFNoVectorFonts = &H800    'Non Autorizza Fonts Vettoriali
Private Const cdlCFPrinterFonts = &H2       'Lista solo Fonts supportati dalla Stampante hDC
'Private Const cdlCFScalableOnly = &H20000   'Solo fonts che possono essere Scaled
'Private Const cdlCFScreenFonts = &H1        'Solo fonts supportati dal sistema
'Private Const cdlCFTTOnly = &H40000         'Solo Fonts TrueType
'Private Const cdlCFWYSIWYG = &H8000         'Solo Fonts supportati da Screen e Printer

'Show Printer
'Private Const cdlPDAllPages = &H0           'Stato di All Pagesoption button.
'Private Const cdlPDCollate = &H10           'Stato di Collatecheck box.
'Private Const cdlPDDisablePrintToFile = &H80000 'Disabilita Stampa su File
'Private Const cdlPDHelpButton = &H800       'Help Button
'Private Const cdlPDHidePrintToFile = &H100000 'Nasconde Stampa Su File
'Private Const cdlPDNoPageNums = &H8         'Disabilita il controllo delle Pagine da stampare
'Private Const cdlPDNoSelection = &H4        'Disabilita il Selection option button.
'Private Const cdlPDNoWarning = &H80         'Messaggio se non c' stampante predefinita
'Private Const cdlPDPageNums = &H2           'Stato di Pages option button.
'Private Const cdlPDPrintSetup = &H40        'Fa vedere il Print Setup Dialog Box al posto del Print normale
'Private Const cdlPDPrintToFile = &H20       'Stato del Bottone Print To File
'Private Const cdlPDReturnDC = &H100         'Returns adevice context for the printer selection made in the dialog box. The device context is returned in the dialog box's hDC property.
'Private Const cdlPDReturnDefault = &H400    'Restituisce il Nome della stampante predefinita
'Private Const cdlPDReturnIC = &H200         'Returns an information context for the printer selection made in the dialog box. An information context provides a fast way to get information about the device without creating a device context. The information context is returned in the dialog box's hDC property.
'Private Const cdlPDSelection = &H1          'Stato di Selection option button. If neither cdlPDPageNums nor cdlPDSelection is specified, the All option button is in the selected state.
'Private Const cdlPDUseDevModeCopies = &H40000 'If a printer driver doesn't support multiple copies, setting this flag disables the copies edit control. If a driver does support multiple copies, setting this flag indicates that the dialog box stores the requested number of copies in the Copies property.

'Show Help
'Private Const cdlHelpCommandHelp = &H102    'Visualizza Help per un particolare comando
'Private Const cdlHelpContents = &H3         'Visualizza il contents topic del file corrente
Private Const cdlHelpContext = &H1          'Visualizza Help per un particolare argomento
'Private Const cdlHelpContextPopup = &H8     'Visualizza un argomento identificato da un context number
'Private Const cdlHelpForceFile = &H9        'Crea un file Help con testo in un solo formato
'Private Const cdlHelpHelpOnHelp = &H4       'Displays Help for using the Help application itself
'Private Const cdlHelpIndex = &H3            'Visualizza il file di Indice
'Private Const cdlHelpKey = &H101            'Visualizza Help per una Parola Chiave
'Private Const cdlHelpPartialKey = &H105     'Chiama il motore di ricerca della guida di windows
'Private Const cdlHelpQuit = &H2             'Notifies the Help application that the specified Help file is no longer in use
'Private Const cdlHelpSetContents = &H5      'Designates a specific topic as the contents topic
'Private Const cdlHelpSetIndex = &H5         'Sets the current index for multi-index Help

'Show Open e Show Save
Private Const cdlOFNAllowMultiselect = &H200     'Multi-selezione    (Apri)
Private Const cdlOFNCreatePrompt = &H2000        'Richiesta Creazione se non esiste (Apri)
Private Const cdlOFNExplorer = &H80000           'Explorer-like
Private Const CdlOFNExtensionDifferent = &H400   'Indica che l'estensione del file scleto  diversa da quella indicata
Private Const cdlOFNFileMustExist = &H1000       'Solo Files esistenti    (Apri)
Private Const cdlOFNHelpButton = &H10            'Visualizza Help Button
Private Const cdlOFNHideReadOnly = &H4           'Nsconde Read Onlycheck box.    (Apri)
Private Const cdlOFNLongNames = &H200000         'Usa long filenames.
Private Const cdlOFNNoChangeDir = &H8            'Forza a scegliere un file della cartella corrente
Private Const CdlOFNNoDereferenceLinks = &H100000 'Non deferenzia i Links
Private Const cdlOFNNoLongNames = &H40000        'No long file names.
Private Const CdlOFNNoReadOnlyReturn = &H8000    'Il file non sar di Sola Lettura
Private Const cdlOFNNoValidate = &H100           'Autorizza caratteri non validi nel nome del file
Private Const cdlOFNOverwritePrompt = &H2        'Conferma di Sovrascrittura    (Salva)
Private Const cdlOFNPathMustExist = &H800        'Solo Percorsi Validi
Private Const cdlOFNReadOnly = &H1               'Valore del ReadOnly CheckBox
Private Const cdlOFNShareAware = &H4000          'Ignora files gi occupati

'Posizione del CommonDialog da utilizzare
Public MyCommonDialog As BGSCommonDialog

'Funzioni utili
'********************************************************************
'**********         APERTURA FILES
'********************************************************************
Public Function openFileEasy(Messaggio As String, Filtro As String, Optional percorsoIniziale As String = "") As String
Dim MFlags As Long
MFlags = cdlOFNExplorer + cdlOFNFileMustExist + cdlOFNHideReadOnly + cdlOFNPathMustExist

With MyCommonDialog
    .Flags = MFlags
    .InitDir = getFilePath(percorsoIniziale)
    .fileName = "" 'percorsoIniziale
    .Filter = Filtro
    .DialogTitle = Messaggio
    .ShowOpen
    openFileEasy = .fileName
    If InStr(1, openFileEasy, Chr(0)) > 0 Then openFileEasy = Left(openFileEasy, InStr(1, openFileEasy, Chr(0)) - 1)

End With
End Function

'********************************************************************
'**********         SALVATAGGIO FILES
'********************************************************************
Public Function saveFileEasy(Messaggio As String, Filtro As String, Optional percorsoIniziale As String = "", Optional formatChosen As Integer) As String
Dim MFlags As Long
MFlags = cdlOFNExplorer + CdlOFNNoReadOnlyReturn + cdlOFNHideReadOnly + cdlOFNPathMustExist + cdlOFNOverwritePrompt + CdlOFNExtensionDifferent
With MyCommonDialog
    .Flags = MFlags
    If Len(percorsoIniziale) Then .InitDir = getFilePath(percorsoIniziale)

    '.fileName = percorsoIniziale
    .Filter = Filtro
    .DialogTitle = Messaggio
    .ShowSave
    saveFileEasy = .fileName
    formatChosen = .FilterIndex
    If InStr(1, saveFileEasy, Chr(0)) > 0 Then saveFileEasy = Left(saveFileEasy, InStr(1, saveFileEasy, Chr(0)) - 1)
    
End With
End Function

'********************************************************************
'ARGOMENTI DELLA GUIDA
'********************************************************************
Public Sub setHelpFile(HelpFileName As String)
MyCommonDialog.HelpFile = HelpFileName
End Sub

Public Sub openHelpId(IndicePagina As Long)
'Apre la pagina della guida secondo il numero attribuitole
With MyCommonDialog
    .HelpCommand = cdlHelpContext
    .HelpContext = IndicePagina
    .ShowHelp
End With
End Sub

'Public Sub openHelpFirstPage()
'With MyCommonDialog
'    .HelpCommand = cdlHelpIndex
'    .ShowHelp
'End With
'End Sub

'Public Sub openHelpOnHelp()
'With MyCommonDialog
'    .HelpCommand = cdlHelpHelpOnHelp
'    .ShowHelp
'End With
'End Sub

'Public Sub openHelpIndexKey()
'With MyCommonDialog
'    .HelpCommand = cdlHelpKey
'    .ShowHelp
'End With
'End Sub

'Public Sub closeHelpWindow()
'With MyCommonDialog
'    .HelpCommand = cdlHelpQuit
'    .ShowHelp
'End With
'End Sub
