Attribute VB_Name = "LinguaggioProgManager"
'*********************************************************************
'Info:  File di linguaggio per ProgramManager
'*********************************************************************
'Variabili gobali
Public Infos(0 To 5) As String
Public Errors(0 To 13) As String
Public Richieste(0 To 4) As String

Public Sub SetLinguaggioDiDefault()
'Informazioni
Infos(0) = "Riempi i campi (quelli in rosso sono obbligatori), poi seleziona ""Ok/Next"" oppure ""Stop/Undo"" per rendere effettive (o meno) le modifiche."
Infos(1) = "Tutti i Files"
Infos(2) = "Nessun Elemento soddisfa la ricerca richiesta."
Infos(3) = "Sto lavorando per te... Attendere prego."
Infos(4) = "Termina Operazione"
Infos(5) = "Nessuna Occorrenza trovata."

'Errori
Errors(0) = "Si  verificato un errore durante la creazione del file. Controllare che il percorso sia corretto e non sia di sola lettura."
Errors(1) = "Si  verificato un errore durante l'aggiornamento. Controllare i campi obbligatori."
Errors(2) = "Attenzione, l'archivio  vuoto!"
Errors(3) = "Attenzione, errore imprevisto:"
Errors(4) = "Attenzione, il disco selezionato non esiste; inserire un disco e riprovare."
Errors(5) = "Attenzione, il percorso%PATHindicato non esiste! Selezionare il disco appropriato e/o eventualmente inserire il disco"
Errors(6) = "Attenzione,  necessario indicare un testo nel box a destra! Per maggiori informazioni consultare la guida."
Errors(7) = "Attenzione, controllare i dati immessi. La cartella considerata come base, deve contenere la cartella iniziale; la profondit massima deve essere un intero >= 0."
Errors(8) = "Attenzione, la larghezza impostata non consente di visualizzare correttamente la finestra!"
Errors(9) = "Attenzione, si  verificato un errore durante l'apertura del file. Verificare che il file sia un file Program Manager Corretto!"
Errors(10) = "Attenzione, si  verificato un errore durante l'esportazione del file. Descrizione dell'errore:"
Errors(11) = "Vuoi creare un nuovo archivio? Il programma non pu essere avviato senza scegliere un Database. Per creare un nuovo archivio, scegliere Si, per aprirne uno esistente scegliere No, per uscire dal programma premere Annulla."
Errors(12) = "Attenzione, si  verificato un errore durante il caricamento del linguaggio. Controllare il file."
Errors(13) = "Attenzione, si  verificato un errore durante la stampa. Descrizione dell'errore:"

'Richieste
Richieste(0) = "Indicare il percorso per il nuovo Archivio"
Richieste(1) = "Sicuro di non volere aggiornare questo elemento?"
Richieste(2) = "Indica il percorso dell'archivio esistente"
Richieste(3) = "Indica il nome per il file da importare"
Richieste(4) = "Indica il nome del file del linguaggio"


End Sub

Public Function ChangeLanguage(NomeFile As String) As Boolean
Dim Se As String    'Sezione corrente
Dim i As Integer
Dim t As Integer
Dim d As Integer
Dim tempStr As String


'NomeFile = AppDir & "Languages\" & NomeFileA
'Controllo esistenza e coerenza
If (Dir(NomeFile) = "") Or (App.ProductName <> getIniString(NomeFile, "Info Generali", "program")) Then
    ChangeLanguage = False
    Exit Function
End If

ChangeLanguage = True
'Call setIniVal(NF, "Settings", "LastLanguage", NomeFileA)

'Caricamento linguaggio F_Opzioni
Se = "Option"
For i = 0 To 11
    F_Opzioni.Lab(i).Caption = getIniString(NomeFile, Se, "Lab" & CStr(i), , F_Opzioni.Lab(i).Caption)
Next i
For i = 0 To 4
    F_Opzioni.Ch_Opzioni(i).Caption = getIniString(NomeFile, Se, "Check" & CStr(i), , F_Opzioni.Ch_Opzioni(i).Caption)
Next i
For i = 0 To 2
    F_Opzioni.SSTabEditor.TabCaption(i) = getIniString(NomeFile, Se, "Tabs" & CStr(i), , F_Opzioni.SSTabEditor.TabCaption(i))
Next i
F_Opzioni.Cm_Ok.Caption = getIniString(NomeFile, Se, "Ok", , F_Opzioni.Cm_Ok.Caption)
F_Opzioni.Cm_Annulla.Caption = getIniString(NomeFile, Se, "Cancel", , F_Opzioni.Cm_Annulla.Caption)
F_Opzioni.Cm_Font.Caption = getIniString(NomeFile, Se, "ChangeFont", , F_Opzioni.Cm_Font.Caption)
F_Search.L_TestoAiuto.Caption = getIniString(NomeFile, Se, "Search0", , F_Search.L_TestoAiuto.Caption)

Call SetStrings(NomeFile)

On Error GoTo NoIndex
For i = 0 To F_Principale.Controls.Count - 1
    If TypeOf F_Principale.Controls(i) Is Menu Then
        Se = "Menus"
        tempStr = F_Principale.Controls(i).Name
        F_Principale.Controls(i).Caption = getIniString(NomeFile, Se, tempStr & CStr(F_Principale.Controls(i).Index), , F_Principale.Controls(i).Caption)
    ElseIf TypeOf F_Principale.Controls(i) Is CommandButton Then
        Se = "Menus"
        t = InStr(1, F_Principale.Controls(i).Name, "_Bar")
        If t > 0 Then
            tempStr = Left(F_Principale.Controls(i).Name, t) & Right(F_Principale.Controls(i).Name, Len(F_Principale.Controls(i).Name) - t - 4)
            F_Principale.Controls(i).ToolTipText = RemoveCommercialE(getIniString(NomeFile, Se, tempStr & CStr(F_Principale.Controls(i).Index), , F_Principale.Controls(i).ToolTipText))
        End If
    ElseIf TypeOf F_Principale.Controls(i) Is Label Then
        Se = "Labels"
        F_Principale.Controls(i).Caption = getIniString(NomeFile, Se, F_Principale.Controls(i).Name & CStr(F_Principale.Controls(i).Index), , F_Principale.Controls(i).Caption)
    End If
Next i

Call SetNomeCampi

Exit Function
NoIndex:
If TypeOf F_Principale.Controls(i) Is Menu Then
    F_Principale.Controls(i).Caption = getIniString(NomeFile, Se, tempStr, , F_Principale.Controls(i).Caption)
Else
    F_Principale.Controls(i).ToolTipText = RemoveCommercialE(getIniString(NomeFile, Se, tempStr, , F_Principale.Controls(i).ToolTipText))
End If
err.Clear
Resume Next
End Function

Public Sub SetStrings(NomeFile As String)
Dim Se As String
'Impostazione Stringhe Varie
Se = "Strings"

For i = 0 To UBound(Infos)
    Infos(i) = getIniString(NomeFile, Se, "Infos" & CStr(i), , Infos(i))
Next i
For i = 0 To UBound(Errors)
    Errors(i) = getIniString(NomeFile, Se, "Errors" & CStr(i), , Errors(i))
Next i
For i = 0 To UBound(Richieste)
    Richieste(i) = getIniString(NomeFile, Se, "Richieste" & CStr(i), , Richieste(i))
Next i
'Fine STRINGHE

End Sub

Private Function RemoveCommercialE(OldString As String) As String
Dim t As Integer
t = InStr(1, OldString, "&")
RemoveCommercialE = OldString
Do While t > 0
    RemoveCommercialE = Left(RemoveCommercialE, t - 1) & Right(RemoveCommercialE, Len(RemoveCommercialE) - t)
    t = InStr(1, RemoveCommercialE, "&")
Loop
End Function
